package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.annotation.JsonBackReference;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiAdesionePfKey;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DrichAdesionePfKey;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_ESITI_RICH_ADESIONE_PF")
public class DesitiRichAdesionePf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 4149647883L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DesitiRichAdesionePf.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_ESITO_RICH_ADESIONE_PF", columnDefinition = "NUMBER(15)")
	private Long sequIdEsitoRichAdesionePf;
	@Column(name = "TEXT_MOTIVAZIONI_RIFIUTO", columnDefinition = "LONGTEXT")
	private String textMotivazioniRifiuto;
	@Column(name = "TEXT_NOTE_AMMINISTRATO", columnDefinition = "LONGTEXT")
	private String textNoteAmministrato;
	@Column(name = "TEXT_NOTE_RESPONSABILE", columnDefinition = "LONGTEXT")
	private String textNoteResponsabile;
	@NotNull

	@Column(name = "FK_AMMINISTRATO", columnDefinition = "NUMBER(15)")
	private Long fkAmministrato;
	@NotNull

	@Column(name = "FK_RICH_ADESIONE_PF", columnDefinition = "NUMBER(15)")
	private Long fkRichAdesionePf;
	@NotNull

	@Column(name = "FK_STATO_RICH_ADESIONE", columnDefinition = "NUMBER(15)")
	private Long fkStatoRichAdesione;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DesitiRichAdesionePf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DesitiRichAdesionePf(DesitiRichAdesionePfKey desitiRichAdesionePfKey, Long sequIdEsitoRichAdesionePf,
			String textMotivazioniRifiuto, String textNoteAmministrato, String textNoteResponsabile,
			Long fkAmministrato, Long fkRichAdesionePf, Long fkStatoRichAdesione, String flagEliminato,
			String utenteUltimaModifica, Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.desitiRichAdesionePfKey = desitiRichAdesionePfKey;

		this.sequIdEsitoRichAdesionePf = sequIdEsitoRichAdesionePf;
		this.textMotivazioniRifiuto = textMotivazioniRifiuto;
		this.textNoteAmministrato = textNoteAmministrato;
		this.textNoteResponsabile = textNoteResponsabile;
		this.fkAmministrato = fkAmministrato;
		this.fkRichAdesionePf = fkRichAdesionePf;
		this.fkStatoRichAdesione = fkStatoRichAdesione;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDesitiRichAdesionePf")
	@OneToMany(mappedBy = "theDesitiRichAdesionePf", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DpianificFerieAmmto> theDpianificFerieAmmto = new ArrayList<>();

	// PARENTS
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDstatiAdesionePf")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DstatiAdesionePf theDstatiAdesionePf;
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDrichAdesionePf")
	@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" }, allowSetters = true)
	private DrichAdesionePf theDrichAdesionePf;

	// GETTER/SETTER
	/**
	 * @return the sequIdEsitoRichAdesionePf
	 */
	public Long getSequIdEsitoRichAdesionePf() {
		return this.sequIdEsitoRichAdesionePf;
	}

	/**
	 * @param sequIdEsitoRichAdesionePf to set
	 */
	public void setSequIdEsitoRichAdesionePf(Long sequIdEsitoRichAdesionePf) {
		this.sequIdEsitoRichAdesionePf = sequIdEsitoRichAdesionePf;
	}

	/**
	 * @return the textMotivazioniRifiuto
	 */
	public String getTextMotivazioniRifiuto() {
		return this.textMotivazioniRifiuto;
	}

	/**
	 * @param textMotivazioniRifiuto to set
	 */
	public void setTextMotivazioniRifiuto(String textMotivazioniRifiuto) {
		this.textMotivazioniRifiuto = textMotivazioniRifiuto;
	}

	/**
	 * @return the textNoteAmministrato
	 */
	public String getTextNoteAmministrato() {
		return this.textNoteAmministrato;
	}

	/**
	 * @param textNoteAmministrato to set
	 */
	public void setTextNoteAmministrato(String textNoteAmministrato) {
		this.textNoteAmministrato = textNoteAmministrato;
	}

	/**
	 * @return the textNoteResponsabile
	 */
	public String getTextNoteResponsabile() {
		return this.textNoteResponsabile;
	}

	/**
	 * @param textNoteResponsabile to set
	 */
	public void setTextNoteResponsabile(String textNoteResponsabile) {
		this.textNoteResponsabile = textNoteResponsabile;
	}

	/**
	 * @return the fkAmministrato
	 */
	public Long getFkAmministrato() {
		return this.fkAmministrato;
	}

	/**
	 * @param fkAmministrato to set
	 */
	public void setFkAmministrato(Long fkAmministrato) {
		this.fkAmministrato = fkAmministrato;
	}

	/**
	 * @return the fkRichAdesionePf
	 */
	public Long getFkRichAdesionePf() {
		return this.fkRichAdesionePf;
	}

	/**
	 * @param fkRichAdesionePf to set
	 */
	public void setFkRichAdesionePf(Long fkRichAdesionePf) {
		this.fkRichAdesionePf = fkRichAdesionePf;
	}

	/**
	 * @return the fkStatoRichAdesione
	 */
	public Long getFkStatoRichAdesione() {
		return this.fkStatoRichAdesione;
	}

	/**
	 * @param fkStatoRichAdesione to set
	 */
	public void setFkStatoRichAdesione(Long fkStatoRichAdesione) {
		this.fkStatoRichAdesione = fkStatoRichAdesione;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DpianificFerieAmmto
	 */
	public Collection<DpianificFerieAmmto> getTheDpianificFerieAmmto() {
		return theDpianificFerieAmmto;
	}

	/**
	 * @param aDpianificFerieAmmtoList to set
	 */
	public void setTheDpianificFerieAmmto(Collection<DpianificFerieAmmto> aDpianificFerieAmmtoList) {
		theDpianificFerieAmmto = aDpianificFerieAmmtoList;
	}

	/// ADD CHILD
	public void addDpianificFerieAmmto(DpianificFerieAmmto dpianificFerieAmmto) {
		theDpianificFerieAmmto.add(dpianificFerieAmmto);
	}

	// PARENT GETTER/SETTER
	/**
	 * @return the DstatiAdesionePf
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DstatiAdesionePf getTheDstatiAdesionePf() {
		return theDstatiAdesionePf;
	}

	/**
	 * @param aDstatiAdesionePfList to set
	 */
	public void setTheDstatiAdesionePf(DstatiAdesionePf aDstatiAdesionePf) {
		theDstatiAdesionePf = aDstatiAdesionePf;
	}

	/**
	 * @return the DrichAdesionePf
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DrichAdesionePf getTheDrichAdesionePf() {
		return theDrichAdesionePf;
	}

	/**
	 * @param aDrichAdesionePfList to set
	 */
	public void setTheDrichAdesionePf(DrichAdesionePf aDrichAdesionePf) {
		theDrichAdesionePf = aDrichAdesionePf;
	}

	// PARENT ID GETTER/SETTER
	/**
	 * Return the dstatiAdesionePfKey from theDstatiAdesionePf.
	 * 
	 * @return dstatiAdesionePfKey from theDstatiAdesionePf.
	 */
	@JsonProperty
	public DstatiAdesionePfKey getDstatiAdesionePfKey() {
		// If the parent entity object is null, then return null
		if (getTheDstatiAdesionePf() == null) {
			return null;
		}
		// Return requested attribute
		return theDstatiAdesionePf.getDstatiAdesionePfKey();
	}

	/**
	 * Return the drichAdesionePfKey from theDrichAdesionePf.
	 * 
	 * @return drichAdesionePfKey from theDrichAdesionePf.
	 */
	@JsonProperty
	public DrichAdesionePfKey getDrichAdesionePfKey() {
		// If the parent entity object is null, then return null
		if (getTheDrichAdesionePf() == null) {
			return null;
		}
		// Return requested attribute
		return theDrichAdesionePf.getDrichAdesionePfKey();
	}

	// PARENT OBJECT TITLE
	/**
	 * Return the object title of theDstatiAdesionePf.
	 * 
	 * @return the object title of theDstatiAdesionePf.
	 */
	@JsonProperty
	public String getTheDstatiAdesionePfObjectTitle() {
		return getTheDstatiAdesionePf() != null ? getTheDstatiAdesionePf().getObjectTitle() : null;
	}

	/**
	 * Return the object title of theDrichAdesionePf.
	 * 
	 * @return the object title of theDrichAdesionePf.
	 */
	@JsonProperty
	public String getTheDrichAdesionePfObjectTitle() {
		return getTheDrichAdesionePf() != null ? getTheDrichAdesionePf().getObjectTitle() : null;
	}

	// PARENT OBJECT KEY
	/**
	 * Return the object key of theDstatiAdesionePf.
	 * 
	 * @return the object key of theDstatiAdesionePf.
	 */
	@JsonProperty
	public String getTheDstatiAdesionePfObjectKey() {
		return getTheDstatiAdesionePf() != null ? getTheDstatiAdesionePf().getObjectKey() : null;
	}

	/**
	 * Set object key of theDstatiAdesionePf.
	 * 
	 */
	@JsonProperty
	public void setTheDstatiAdesionePfObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDstatiAdesionePfObjectKey(), objectKey, false)) {
			DstatiAdesionePf dstatiAdesionePf = new DstatiAdesionePf();
			dstatiAdesionePf.setObjectKey(objectKey);
			setTheDstatiAdesionePf(dstatiAdesionePf);
		}
	}

	/**
	 * Return the object key of theDrichAdesionePf.
	 * 
	 * @return the object key of theDrichAdesionePf.
	 */
	@JsonProperty
	public String getTheDrichAdesionePfObjectKey() {
		return getTheDrichAdesionePf() != null ? getTheDrichAdesionePf().getObjectKey() : null;
	}

	/**
	 * Set object key of theDrichAdesionePf.
	 * 
	 */
	@JsonProperty
	public void setTheDrichAdesionePfObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDrichAdesionePfObjectKey(), objectKey, false)) {
			DrichAdesionePf drichAdesionePf = new DrichAdesionePf();
			drichAdesionePf.setObjectKey(objectKey);
			setTheDrichAdesionePf(drichAdesionePf);
		}
	}

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDesitiRichAdesionePfKey());
	}

	public String getObjectKeyById(DesitiRichAdesionePfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		desitiRichAdesionePfKey = new DesitiRichAdesionePfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getFlagEliminato());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DesitiRichAdesionePfKey desitiRichAdesionePfKey;

	// GETTER/SETTER CK
	/**
	 * @return the desitiRichAdesionePfKey
	 */
	public DesitiRichAdesionePfKey getDesitiRichAdesionePfKey() {
		return this.desitiRichAdesionePfKey;
	}

	/**
	 * @param desitiRichAdesionePfKey to set
	 */
	public void setDesitiRichAdesionePfKey(DesitiRichAdesionePfKey desitiRichAdesionePfKey) {
		this.desitiRichAdesionePfKey = desitiRichAdesionePfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (desitiRichAdesionePfKey == null) {
			desitiRichAdesionePfKey = new DesitiRichAdesionePfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DesitiRichAdesionePf that = (DesitiRichAdesionePf) o;
		return desitiRichAdesionePfKey != null && Objects.equals(desitiRichAdesionePfKey, that.desitiRichAdesionePfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(desitiRichAdesionePfKey);
	}
}
